# MemoryVariableStore

Class in [Yarn](/api/csharp/yarn.md)

Inherits from `System.Object`

## Summary

A simple concrete implementation of [IVariableStorage](/api/csharp/yarn/yarn.ivariablestorage.md) that keeps all variables in memory.

```csharp
public class MemoryVariableStore : IVariableStorage
```

## Methods

| Name                                                                                                             | Description                                                                                                                                                                                                                                                                                                                      |
| ---------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [Clear()](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.clear.md)                           | Removes all variables from storage.                                                                                                                                                                                                                                                                                              |
| [GetVariableKind(string)](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.getvariablekind.md) | Gets the kind of variable named `name` .                                                                                                                                                                                                                                                                                         |
| [SetValue(string,bool)](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.setvalue-3.md)        | Stores a `bool` in this VariableStorage.                                                                                                                                                                                                                                                                                         |
| [SetValue(string,float)](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.setvalue-2.md)       | Stores a `float` in this VariableStorage.                                                                                                                                                                                                                                                                                        |
| [SetValue(string,string)](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.setvalue-1.md)      | Stores a `string` in this VariableStorage.                                                                                                                                                                                                                                                                                       |
| [TryGetValue(string,T?)](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.trygetvalue.md)      | Given a variable name, attempts to fetch a value for the variable, either from storage, initial values found in [Program](/api/csharp/yarn/yarn.ivariableaccess/yarn.ivariableaccess.program.md) , or by evaluating a smart variable found in [Program](/api/csharp/yarn/yarn.ivariableaccess/yarn.ivariableaccess.program.md) . |

## Properties

| Name                                                                                                                   | Description                                                                                                                                                                                                              |
| ---------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| [Program](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.program.md)                               | Gets or sets the Yarn [Program](/api/csharp/yarn/yarn.ivariableaccess/yarn.ivariableaccess.program.md) that stores information about the initial values of variables, and is able to produce values for smart variables. |
| [SmartVariableEvaluator](/api/csharp/yarn/yarn.memoryvariablestore/yarn.memoryvariablestore.smartvariableevaluator.md) | Gets or sets the object to use when evaluating smart variables.                                                                                                                                                          |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/api/csharp/yarn/yarn.memoryvariablestore.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
